// vMac 0.1 Source
// By Philip Cummins (PC)
// Copyright PC 1997
   
// PC - SCSI Memory Handlers

#define kSCSI_Size       0x00020000   // was 0x100

#define kSCSI_Block_Base 0x00580000
#define kSCSI_Block_Top  0x00600000

#define scsiRd           0x000
#define scsiWr           0x001

#define sCDR             0x000       // current scsi data register  (r/o)
#define sODR             0x000       // output data register        (w/o)
#define sICR             0x010       // initiator command register  (r/w)
#define sMR              0x020       // mode register               (r/w)
#define sTCR             0x030       // target command register     (r/w)
#define sCSR             0x040       // current SCSI bus status     (r/o)
#define sSER             0x040       // select enable register      (w/o)
#define sBSR             0x050       // bus and status register     (r/o)
#define sDMAtx           0x050       // start DMA send              (w/o)
#define sIDR             0x060       // input data register         (r/o)
#define sTDMArx          0x060       // start DMA target receive    (w/o) 
#define sRESET           0x070       // reset parity/interrupt      (r/o)
#define sIDMArx          0x070       // start DMA initiator receive (w/o)
#define dackWr           0x200       // DACK write
#define dackRd           0x200       // DACK read

typedef struct {
   UBYTE RESET;
   UBYTE IRQ;
   UBYTE DRQ;
   UBYTE EOP;
   UBYTE DACK;
   UBYTE READY;
   UBYTE A0;
   UBYTE A1;
   UBYTE A2;
   UBYTE CS;
   UBYTE I_OW;
   UBYTE I_OR;
   UBYTE D0_D7;
   UBYTE MSG;
   UBYTE C_D;
   UBYTE I_O;
   UBYTE ACK;
   UBYTE REQ;
   UBYTE DBP;
   UBYTE DB0_DB7;
   UBYTE RST;
   UBYTE BSY;
   UBYTE SEL;
   UBYTE ATN;
} SCSI_Ty;             // 44-pin PLCC

int   SCSI_Init (void);
void  SCSI_Reset (void);

void  SCSI_Check (void);

UBYTE SCSI_GetB (CPTR addr);
UWORD SCSI_GetW (CPTR addr);
ULONG SCSI_GetL (CPTR addr);

void  SCSI_PutB (CPTR addr, UBYTE in);
void  SCSI_PutW (CPTR addr, UWORD in);
void  SCSI_PutL (CPTR addr, ULONG in);
