#include "sysconfig.h"
#include "sysdeps.h"
#include "config.h"
#include "options.h"
#include "memory.h"
#include "Memory1.h"
#include "custom.h"
#include "readcpu.h"
#include "newcpu.h"
#include "Win32\Win32Port.h"
#include "patch.h"
#include "prefs.h"
#include "screen.h"

int Screen_Patch=0, hideCursor=0, showCursor=0;
int Shutdown=0;
int Top=0, Left=0;

extern UBYTE Sony_Installed;

int patch_screen (void)
{
   ULONG QD_Global, screenBits, crsrPin = 0x834, thePort;
   UWORD Right  = (thePrefs.Big==1) ? Right1  : Right2;
   UWORD Bottom = (thePrefs.Big==1) ? Bottom1 : Bottom2;
   CPTR  jHideCursor=0x800, jShowCursor=0x804, ptr;

   // patch the QD globals
   thePort    = get_long(m68k_areg(regs, 5));
   QD_Global  = thePort - (206 - 4);
   screenBits = QD_Global + 80;

   // patch up the QD globals
   put_long(screenBits   , scrnBase);
   put_word(screenBits+4 , rowBytes2);
   put_word(screenBits+6 , Top);
   put_word(screenBits+8 , Left);
   put_word(screenBits+10, Bottom);
   put_word(screenBits+12, Right);

   // patch the low-level globals
   put_long(0x824, scrnBase);
   put_word(0x106, rowBytes2);
   put_word(0xc20, Right);
   put_word(0xc22, Bottom);

   if (thePrefs.Big==1)
      put_long(0xc24, screenBytes1);
   else
      put_long(0xc24, screenBytes2);

   // patch up mouse for the new screen size
   put_word(crsrPin,   Top);
   put_word(crsrPin+2, Left);
   put_word(crsrPin+4, Bottom);
   put_word(crsrPin+6, Right);

   // Patch ROM routines [Not very efficient, but generic, which is what
   // we need here].  And since it's in ROM, it's not like it's ever
   // going to be changed, so patching this once is enough...

   if (!Screen_Patch) {
      ROMmem_write_enable_set(on);

      // patch _HideCursor
      ptr = get_long(jHideCursor);
      do {                                   // loop through the routine ...
         if (get_long(ptr)==0x70402298)      // patch MOVE.l #$40, D0
            put_byte(ptr+1, rowBytes2);
         ptr+=2;
      } while (get_long(ptr)!=0x4e75);       // ... until we reach RTS.l

      // patch _ShowCursor
      ptr = get_long(jShowCursor);
      do {                                   // loop through the routine ...
         if (get_long(ptr)==0x7a40c2c5)      // patch MOVE.l #$40, D5
            put_byte(ptr+1, rowBytes2);
         if (get_long(ptr)==0x0c4001e0)      // patch CMP.w #$01e0, D0
            put_word(ptr+2, Right-0x20);
         if (get_long(ptr)==0x303c01e0)      // patch MOVE.w #$01e0, D0
            put_word(ptr+2, Right-0x20);
         if (get_long(ptr)==0x0c410146)      // patch CMP.w #$0146, D1
            put_word(ptr+2, Bottom-0x10);
         if (get_long(ptr)==0x383c0156)      // patch MOVE.w #$0156, D4
            put_word(ptr+2, Bottom);
            ptr+=2;
      } while (get_long(ptr)!=0x4e75);       // ... until we reach RTS.l

      ROMmem_write_enable_set(off);
   }

   Screen_Patch=1;
   return 1;
}

int patch_ALine(void)
{
    UpdateScreen=1;

    if(--ROMScreen<=0)
        ROMScreen=0;

    if(ShowTraps)
    {
        char Temp[256];
        _itoa(get_word(m68k_getpc()),Temp,16);
        if(IDCANCEL==MessageBox(MainWnd,Temp,"A-LINE TRAP DEBUG",MB_OKCANCEL))
            ShowTraps=FALSE;
    }

    switch(get_word(m68k_getpc()))
    {
      case 0xA22E: //_BlockMoveData
      case 0xA02E: //_BlockMove
      {
         char *A0; // the source
         char *A1; // the destination
         ULONG D0; // the size

         A0 = get_real_address(m68k_areg(regs, 0)); // the source
         A1 = get_real_address(m68k_areg(regs, 1)); // the destination
         D0 = m68k_dreg(regs, 0); // the size

         memmove(A1, A0, D0);

         m68k_dreg(regs, 0) = 0; // No error

         m68k_setpc(m68k_getpc() + 2); // Immediate Return (RTS)

         return 1;
     }

      case 0xA86E: { //_InitGraf
         Run_ATrap();
         if (thePrefs.Big)
            patch_screen();

         return 1;
      }

    case 0xA9C9: // _SysError with 0x2A
        if(m68k_dreg(regs, 0)==0x2A && thePrefs.AutoQuit)
            Shutdown=1;
        return(0);

    case 0xA851: // Check for a _SetCursor so we know it's done and waiting for mouse input
        if(Shutdown)
            PostMessage(MainWnd, WM_QUIT, NULL, NULL);
        return(0);


    case 0xA895: // Check for a _ShutDown with 2 on the stack - Restart
        if(get_word(m68k_areg(regs, 7))==2)
        {
            ROMScreen=5;
            FloppyReady=FALSE;
        }
        return(0);


	case 0xA9FE: // _PutScrap for the clipboard
		_Native_PutScrap();
		return(0);


    case 0xA9A1: // Check if it's the A line trap "_GetNamedResource"
        if(Sony_Installed==0)
        {
            CPTR NamePtr = get_long(m68k_areg(regs, 7));

			if(	   (get_long(NamePtr)	== 0x052E536F)
				&& (get_word(NamePtr+4)	== 0x6E79)
				&& (get_long(m68k_areg(regs, 7) + 4) )
				== 0x44525652)
			{
				Run_ATrap(); // Call GetNamedResource

				Sony_Install();

				return(1);
			}
        }
        return(0);
    }

    return(0);
}
