// Cross Platform Compatible Preferences Code for vMac
// (C) 1997 Richard Bannister

// Based on code from Frodo - (C) 1994-1997 Christian Bauer

#include "sysconfig.h"
#include "sysdeps.h"
#include "prefs.h"

#ifdef _MacOS
#include "MacOS.h"
#endif

#include <string.h>

Prefs thePrefs;

void PrefsLoad(char *filename)
{
	FILE *file;
	char line[256], keyword[256], value[256];
	int a=0;
	int b=0;

	// Initialise the prefs with valid values
	#ifdef _MacOS
	thePrefs.BlackBackground=false;
	#endif
    #ifndef _Win32
	 thePrefs.FrameRate=1;
	#endif
	strcpy(thePrefs.DrivePath[0], "Disk1.dsk");
	strcpy(thePrefs.DrivePath[1], "Disk2.dsk");
	strcpy(thePrefs.ROMPath[1],"vMac.ROM");
	thePrefs.CurrentROMPath=1;
	thePrefs.RAMSize=4;
        #ifdef _Win32
         thePrefs.DX=0;
         thePrefs.CD=2;
         thePrefs.EjectCD=1;
         thePrefs.Floppy=2;
         thePrefs.FileIcons=1;
         thePrefs.KeyConfig=3;
         thePrefs.AutoQuit=1;
         thePrefs.Sound=1;
         thePrefs.ModemPort=0;
         thePrefs.PrintPort=0;
         thePrefs.AutoInsert=0;

    	 thePrefs.GemulatorBase=0x240;
	     thePrefs.GemulatorSocket=1;
        #endif

    thePrefs.Big=0;

	if ((file = fopen(filename, "r")) != NULL)
	{
		while(fgets(line, 255, file))
		{
            //Fixed bug that prevented using spaces in paths - Weston

		    a=0;

		    //Get keyword
            for(b=0;a<256;++a,++b)
            {
                if(line[a]==' '||line[a]=='\0')
                    break;

                keyword[b]=line[a];
            }
            keyword[b]='\0';

            ++a;

            //Get =
            for(;a<256;++a)
            {
                if(line[a]==' '||line[a]=='\0')
                    break;
            }

            ++a;

		    //Get value
            for(b=0;a<256;++a,++b)
            {
                if(line[a]=='\n')
                    break;

                value[b]=line[a];
            }
            value[b]='\0';

            if(1) //Always do this
			{
				if (!strcmp(keyword, "FrameRate"))
				{
                #ifndef _Win32
					if (!strcmp(value, "1"))
						thePrefs.FrameRate = 1;
					else if (!strcmp(value, "2"))
						thePrefs.FrameRate = 2;
					else if (!strcmp(value, "3"))
						thePrefs.FrameRate = 3;
					else if (!strcmp(value, "4"))
						thePrefs.FrameRate = 4;
					else if (!strcmp(value, "5"))
						thePrefs.FrameRate = 5;
					else if (!strcmp(value, "6"))
						thePrefs.FrameRate = 6;
					else if (!strcmp(value, "7"))
						thePrefs.FrameRate = 7;
					else if (!strcmp(value, "8"))
						thePrefs.FrameRate = 8;
					else if (!strcmp(value, "9"))
						thePrefs.FrameRate = 9;
					else if (!strcmp(value, "10"))
						thePrefs.FrameRate = 10;
                #endif
				}
				else if (!strcmp(keyword, "RAMSize"))
				{
					if (!strcmp(value, "1"))
						thePrefs.RAMSize = 1;
					else if (!strcmp(value, "2"))
						thePrefs.RAMSize = 2;
					else if (!strcmp(value, "4"))
						thePrefs.RAMSize = 4;
				}
				#ifdef _MacOS
				else if (!strcmp(keyword, "BlackBackground"))
					thePrefs.BlackBackground = !strcmp(value, "TRUE");
				#endif

                                #ifdef _Win32

                                else if (!strcmp(keyword, "ModemPort"))
                                    {
                                        int Count;
                                        for(Count=0;Count<5;++Count)
                                            value[Count]=toupper(value[Count]);

                                        if (!strcmp(value, "COM1"))
                                                thePrefs.ModemPort=1;
                                        else if (!strcmp(value, "COM2"))
                                                thePrefs.ModemPort=2;
                                        else if (!strcmp(value, "COM3"))
                                                thePrefs.ModemPort=3;
                                        else if (!strcmp(value, "COM4"))
                                                thePrefs.ModemPort=4;
                                        else if (!strcmp(value, "LPT1"))
                                                thePrefs.ModemPort=5;
                                        else if (!strcmp(value, "LPT2"))
                                                thePrefs.ModemPort=6;
                                        else if (!strcmp(value, "LPT3"))
                                                thePrefs.ModemPort=7;
                                    /* DISABLED - NOT FINISHED YET
                                        else if (!strcmp(value, "FILE"))
                                                thePrefs.ModemPort=8;
                                        else if (!strcmp(value, "MODEM"))
                                                thePrefs.ModemPort=9;
                                    */
                                        else
                                                thePrefs.ModemPort=0;
                                    }

                                else if (!strcmp(keyword, "PrintPort"))
                                    {
                                        int Count;
                                        for(Count=0;Count<3;++Count)
                                            value[Count]=toupper(value[Count]);

                                        if (!strcmp(value, "COM1"))
                                                thePrefs.PrintPort=1;
                                        else if (!strcmp(value, "COM2"))
                                                thePrefs.PrintPort=2;
                                        else if (!strcmp(value, "COM3"))
                                                thePrefs.PrintPort=3;
                                        else if (!strcmp(value, "COM4"))
                                                thePrefs.PrintPort=4;
                                        else if (!strcmp(value, "LPT1"))
                                                thePrefs.PrintPort=5;
                                        else if (!strcmp(value, "LPT2"))
                                                thePrefs.PrintPort=6;
                                        else if (!strcmp(value, "LPT3"))
                                                thePrefs.PrintPort=7;
                                    /* DISABLED - NOT FINISHED YET
                                        else if (!strcmp(value, "FILE"))
                                                thePrefs.PrintPort=8;
                                        else if (!strcmp(value, "PRINT"))
                                                thePrefs.PrintPort=9;
                                    */
                                        else
                                                thePrefs.PrintPort=0;
                                    }

                                else if (!strcmp(keyword, "EjectCD"))
                                        if (!strcmp(value, "0"))
                                                thePrefs.EjectCD=0;
                                        else
                                                thePrefs.EjectCD=1;

                                else if (!strcmp(keyword, "DirectX"))
                                        if (!strcmp(value, "1"))
                                                thePrefs.DX=1;
                                        else
                                                thePrefs.DX=0;

                                else if (!strcmp(keyword, "Floppy"))
                                        if (!strcmp(value, "0"))
                                                thePrefs.Floppy=0;
                                        else if (!strcmp(value, "2"))
                                                thePrefs.Floppy=2;
                                        else if (!strcmp(value, "3"))
                                                thePrefs.Floppy=3;
                                        else
                                                thePrefs.Floppy=1;

                                else if (!strcmp(keyword, "AutoInsert"))
                                        if (!strcmp(value, "1"))
                                                thePrefs.AutoInsert=1;
                                        else if (!strcmp(value, "2"))
                                                thePrefs.AutoInsert=2;
                                        else if (!strcmp(value, "3"))
                                                thePrefs.AutoInsert=3;
                                        else if (!strcmp(value, "4"))
                                                thePrefs.AutoInsert=4;
                                        else if (!strcmp(value, "5"))
                                                thePrefs.AutoInsert=5;
                                        else if (!strcmp(value, "6"))
                                                thePrefs.AutoInsert=6;
                                        else if (!strcmp(value, "7"))
                                                thePrefs.AutoInsert=7;
                                        else if (!strcmp(value, "8"))
                                                thePrefs.AutoInsert=8;
                                        else if (!strcmp(value, "9"))
                                                thePrefs.AutoInsert=9;
                                        else if (!strcmp(value, "10"))
                                                thePrefs.AutoInsert=10;
                                        else if (!strcmp(value, "11"))
                                                thePrefs.AutoInsert=11;
                                        else if (!strcmp(value, "12"))
                                                thePrefs.AutoInsert=12;
                                        else if (!strcmp(value, "13"))
                                                thePrefs.AutoInsert=13;
                                        else if (!strcmp(value, "14"))
                                                thePrefs.AutoInsert=14;
                                        else if (!strcmp(value, "15"))
                                                thePrefs.AutoInsert=15;
                                        else if (!strcmp(value, "16"))
                                                thePrefs.AutoInsert=16;
                                        else if (!strcmp(value, "17"))
                                                thePrefs.AutoInsert=17;
                                        else if (!strcmp(value, "18"))
                                                thePrefs.AutoInsert=18;
                                        else if (!strcmp(value, "19"))
                                                thePrefs.AutoInsert=19;
                                        else if (!strcmp(value, "20"))
                                                thePrefs.AutoInsert=20;
                                        else
                                                thePrefs.AutoInsert=0;

                                else if (!strcmp(keyword, "CD"))
                                        if (!strcmp(value, "0"))
                                                thePrefs.CD=0;
                                        else if (!strcmp(value, "2"))
                                                thePrefs.CD=2;
                                        else if (!strcmp(value, "3"))
                                                thePrefs.CD=3;
                                        else
                                                thePrefs.CD=1;

                                else if (!strcmp(keyword, "FileIcons"))
                                        if (!strcmp(value, "0"))
                                                thePrefs.FileIcons=0;
                                        else
                                                thePrefs.FileIcons=1;

                                else if (!strcmp(keyword, "KeyConfig"))
                                        if (!strcmp(value, "1"))
                                                thePrefs.KeyConfig=1;
                                        else if (!strcmp(value, "2"))
                                                thePrefs.KeyConfig=2;
                                        else
                                                thePrefs.KeyConfig=3;


                                else if (!strcmp(keyword, "AutoQuit"))
                                        if (!strcmp(value, "0"))
                                                thePrefs.AutoQuit=0;
                                        else
                                                thePrefs.AutoQuit=1;

                                else if (!strcmp(keyword, "Sound"))
                                        if (!strcmp(value, "0"))
                                                thePrefs.Sound=0;
                                        else
                                                thePrefs.Sound=1;

                    			else if (!strcmp(keyword, "GemulatorBase"))
				                {
                				    sscanf(value,"%X",&thePrefs.GemulatorBase);
				                }
            				    else if (!strcmp(keyword, "GemulatorSocket"))
			                	{
			                	    //Max 7 because length is always 2, so a value of 7 means 7 and 8
                				    if(atoi(value)>=1 && atoi(value)<=7)
    			                	    thePrefs.GemulatorSocket=atoi(value);
                    			}
                                #endif

				#ifndef _MacOS // MacOS Port doesn't support paths yet

				//Fixed DrivePath bug - Weston
				//Was DrivePath[1] and DrivePath[2]
				//Now DrivePath[0] and DrivePath[1]

				else if (!strcmp(keyword, "DrivePath1"))
					strcpy(thePrefs.DrivePath[0], value);
				else if (!strcmp(keyword, "DrivePath2"))
					strcpy(thePrefs.DrivePath[1], value);
				else if (!strcmp(keyword, "ROMPath1"))
					strcpy(thePrefs.ROMPath[1],value);
				else if (!strcmp(keyword, "ROMPath2"))
					strcpy(thePrefs.ROMPath[2],value);
				else if (!strcmp(keyword, "ROMPath3"))
					strcpy(thePrefs.ROMPath[3],value);
				else if (!strcmp(keyword, "CurrentROMPath"))
				{
					if (!strcmp(value, "1"))
						thePrefs.CurrentROMPath = 1;
					else if (!strcmp(value, "2"))
						thePrefs.CurrentROMPath = 2;
					else if (!strcmp(value, "3"))
						thePrefs.CurrentROMPath = 3;
                #ifdef _Win32
				    else if (!strcmp(value, "G") || !strcmp(value, "g"))
				        thePrefs.CurrentROMPath = 255;
                #endif //_Win32
				}
				#endif
			}
		}
		fclose(file);
	}
}

void PrefsSave(char *filename)
{
	FILE *file;

	if ((file = fopen(filename, "w")) != NULL) {
		fprintf(file, "// vMac Configuration File\n");
		fprintf(file, "//\n");

		// MacOS Port; All options here will be configurable from the vMac application
		// If you want to add these lines in your port feel free - Richard Bannister
		#ifdef _MacOS
			fprintf(file, "// These options can all be changed from within the vMac\n");
			fprintf(file, "// application - there is no need to edit them here\n");
		#endif

		fprintf(file, "\n");

        #ifndef _Win32
		fprintf(file, "// How many frames should be displayed? vMac by default\n");
		fprintf(file, "// draws every frame (1) but on slower machines the\n");
		fprintf(file, "// emulation speed can be adjusted by entering a higher\n");
		fprintf(file, "// figure here. (Minimum value = 1, Maximum Value = 10).\n\n");
		fprintf(file, "FrameRate = %d\n\n", thePrefs.FrameRate);
        #endif

		#ifdef _MacOS
		fprintf(file, "// Do you want a black background covering the screen\n");
		fprintf(file, "// or do you want the emulator to run in a window?\n\n");
		fprintf(file, "BlackBackground = %s\n\n", thePrefs.BlackBackground ? "TRUE" : "FALSE");
		#endif

        #ifdef _Win32

        fprintf(file, "// Which ports (COM1-4 or LPT1-3) do you want to use as the modem and\n");
        fprintf(file, "// printer ports? Set to 0 if you don't want to use a real port.\n\n");

        if(thePrefs.ModemPort>=1 && thePrefs.ModemPort<=4)
            fprintf(file, "ModemPort = COM%d\n", thePrefs.ModemPort);
        else if(thePrefs.ModemPort>=5 && thePrefs.ModemPort<=7)
            fprintf(file, "ModemPort = LPT%d\n", thePrefs.ModemPort-4);
    /* DISABLED - NOT FINISHED YET
        else if(thePrefs.ModemPort==8)
            fprintf(file, "ModemPort = FILE\n");
        else if(thePrefs.ModemPort==9)
            fprintf(file, "ModemPort = MODEM\n");
    */
        else
            fprintf(file, "ModemPort = 0\n");

        if(thePrefs.PrintPort>=1 && thePrefs.PrintPort<=4)
            fprintf(file, "PrintPort = COM%d\n\n", thePrefs.PrintPort);
        else if(thePrefs.PrintPort>=5 && thePrefs.PrintPort<=7)
            fprintf(file, "PrintPort = LPT%d\n\n", thePrefs.PrintPort-4);
    /* DISABLED - NOT FINISHED YET
        else if(thePrefs.PrintPort==8)
            fprintf(file, "PrintPort = FILE\n");
        else if(thePrefs.PrintPort==9)
            fprintf(file, "PrintPort = PRINT\n");
    */
        else
            fprintf(file, "PrintPort = 0\n\n");


        fprintf(file, "// Do you want to use DirectX for fast, full screen video?\n");
        fprintf(file, "// This will require an installation of DirectX 2.0 or higher,\n");
        fprintf(file, "// and DirectX compatible graphics hardware. Set it to 1 if you\n");
        fprintf(file, "// want to use DirectX mode, or 0 if you want to use window mode\n\n");
        fprintf(file, "DirectX = %d\n\n", thePrefs.DX);

        fprintf(file, "// Do you want to be able to use 1.4MB Floppies? This should\n");
        fprintf(file, "// work on most computers, but some have trouble it. Set to:\n");
        fprintf(file, "// 0=Floppy support off, 1=Floppy support on, 2=On, but no messages\n");
        fprintf(file, "// under DirectX mode, 3=On, but no messages at all\n\n");
        fprintf(file, "Floppy = %d\n\n", thePrefs.Floppy);

        fprintf(file, "// Do you want vMac to scan for floppies at a regular interval?\n");
        fprintf(file, "// It seems to work best under Windows 98, but causes slowing under 95\n");
        fprintf(file, "// This should make it automatically mount a disk shortly after you\n");
        fprintf(file, "// insert it. Set to 0 for no, otherwise set to the interval (1-20)\n\n");
        fprintf(file, "AutoInsert = %d\n\n", thePrefs.AutoInsert);

        fprintf(file, "// Do you want to use Mac CD-ROMs? Set to: 0=Mac CD-ROM support off,\n");
        fprintf(file, "// 1=Mac CD-ROM support on, 2=On, but no messages under DirectX mode,\n");
        fprintf(file, "// 3=On, but no messages at all\n\n");
        fprintf(file, "CD = %d\n\n", thePrefs.CD);

        fprintf(file, "// Do you want vMac to eject CDs when the MacOS ejects them?\n");
        fprintf(file, "// Set to 1 if you do, or 0 if you don't\n\n");
        fprintf(file, "EjectCD = %d\n\n", thePrefs.EjectCD);

        fprintf(file, "// Do you want vMac to give .DSK and .ROM files an icon?\n");
        fprintf(file, "// Set to 1 if you do, or 0 if you don't\n\n");
        fprintf(file, "FileIcons = %d\n\n", thePrefs.FileIcons);

        fprintf(file, "// Which key configuration do you want to use?\n");
        fprintf(file, "//  1: Left control is command, right control is option.\n");
        fprintf(file, "//  2: Alt is command, and control is option.\n");
        fprintf(file, "//  3: (default) Left alt is command, right alt is option, and\n");
        fprintf(file, "//     control is control.\n\n");
        fprintf(file, "KeyConfig = %d\n\n", thePrefs.KeyConfig);

        fprintf(file, "// Do you want vMac to automatically quit when you\n");
        fprintf(file, "// go to Special-Shutdown? Set to 1 if you do, or 0\n");
        fprintf(file, "// if you don't. This isn't perfect, so if vMac starts\n");
        fprintf(file, "// quiting for no reason at all, turn this option off.\n\n");
        fprintf(file, "AutoQuit = %d\n\n", thePrefs.AutoQuit);

        fprintf(file, "// Do you want vMac to play sound? Set to 1 if you do,\n");
        fprintf(file, "// or 0 if you don't.\n\n");
        fprintf(file, "Sound = %d\n\n", thePrefs.Sound);
 		#endif

		fprintf(file, "// How much RAM do you want the emulated Mac to have?\n");
		fprintf(file, "// (1 = 1 MB, 2 = 2MB, 4 = 4MB).\n\n");
		fprintf(file, "RAMSize = %d\n\n", thePrefs.RAMSize);

		#ifndef _MacOS // MacOS Port doesn't support drive paths
		fprintf(file, "// Which disks are in the emulated disk drives? Where\n");
		fprintf(file, "// are they located?\n\n");
		fprintf(file, "DrivePath1 = %s\n", thePrefs.DrivePath[0]);
		fprintf(file, "DrivePath2 = %s\n\n", thePrefs.DrivePath[1]);

		fprintf(file, "// And where is the vMac.ROM file? If you have more\n");
		fprintf(file, "// than one you can put in the path for them all and\n");
		fprintf(file, "// vMac will allow you to switch between them!\n\n");
		fprintf(file, "ROMPath1 = %s\n", thePrefs.ROMPath[1]);
		fprintf(file, "ROMPath2 = %s\n", thePrefs.ROMPath[2]);
		fprintf(file, "ROMPath3 = %s\n", thePrefs.ROMPath[3]);

        #ifdef _Win32
		  if(thePrefs.CurrentROMPath==255)
	    	fprintf(file, "CurrentROMPath = G\n");
  		  else
		#endif //_Win32
    		fprintf(file, "CurrentROMPath = %d\n", thePrefs.CurrentROMPath);

		fprintf(file, "\n");

		#endif

        #ifdef _Win32
		fprintf(file, "// vMac also supports Gemulator ROM boards. To\n");
		fprintf(file, "// use a Gemulator ROM board, use G as the value\n");
		fprintf(file, "// for CurrentROMPath and set the Gemulator ROM\n");
		fprintf(file, "// board settings below\n");

		fprintf(file, "\n");

        fprintf(file, "// What is the base address (in hex) of the Gemulator\n");
        fprintf(file, "// ROM board? Default is 240. Consult the Gemulator\n");
        fprintf(file, "// documentation for more information.\n\n");
        fprintf(file, "GemulatorBase = %X\n", thePrefs.GemulatorBase);

		fprintf(file, "\n");

        fprintf(file, "// What is the number (1-7) of the first socket on\n");
        fprintf(file, "// the on the Gemulator ROM board that contains the\n");
        fprintf(file, "// ROM set that you want to use?  There are 2 ROMs in\n");
        fprintf(file, "// a MacPlus ROM set, specify the first socket number.\n\n");
        fprintf(file, "GemulatorSocket = %d\n", thePrefs.GemulatorSocket);

		fprintf(file, "\n");

        #endif //_Win32

		fprintf(file, "\n");
		fprintf(file, "// End of File");
		fclose(file);
	}
}
